<?php
//===================================================================================
///                                                    Fichier : getUploadedFile.php
///===================================================================================
///
///====================================================================================
///    function getUploadedFile ($inputFic, $dir='.', $extOK='') { global $debugAppli;
    function getUploadedFile ($inputFic, $dir='.', $extOK='', $errMsg='getUploadedFile') { global $debugAppli;
///====================================================================================
/// Traiter le tlchargement d'un fichier
///
/// Paramtres
///    $inputFic      <file field name>
///                   => $$inputFic          = Nom du fichier temporaire tlcharg
///                   => ${${inputFic}_name} = Nom du fichier origine
///                   => ${${inputFic}_size} = Taille du fichier
///                   => ${${inputFic}_mime} = Type du fichier
///    $dir           Rpertoire o sera transfr le fichier tlcharg
///                     (dfaut: pas de changement de rpertoire)
///    $extOK         Extensions de fichiers autorises
///    $errMsg        Identification de l'appli/contexte en cas d'erreur
///
/// Note : On suppose que le formulaire origine contient le champ :
///            <INPUT TYPE="FILE" NAME="<file field name>">
///
/// Variables globales
///    $Erreur_getUpLoadedFile  Non vide si erreur pendant l'enregistrement
///                             ou le stockage du fichier
///                             NB: La fonction retourne alors un nom de fichier vide
///
///====================================================================================
///
/// Retourne le chemin vers le fichier tlcharg
///       (vide en cas d'erreur - voir alors la variable globale $Erreur_getUpLoadedFile)
///
/// Exemple d'utilisation :
///    <FORM ...>
///    .......
///        <INPUT TYPE="FILE" NAME="MonFichier">
///      .......
///    </FORM>
///    .......
///    $nomFichier     = getUploadedFile($MonFichier, 'MesDocuments');
///    $contenuFichier = join( '', file($nomFichier) );
///    .......
///
///-------------------------------------------------------------------------------
    global $Erreur_getUpLoadedFile;
    $Erreur_getUpLoadedFile = '';
///-------------------------------------------------------------------------------
//
// Conversion des caractres accentus
// Utilisation : $txt = strtr ( $txt, $carsAccent, $carsSsAccent);

    $carsAccent   = '';
    $carsSsAccent = 'eeacaaeeiioouuaaeeiioouuu';

// Extensions non interdites en dur !!!
    $goodExt = '.txt,.rtf,.pdf,.csv,.doc,.xls,.jpg,.jpeg,.bmp,.tif,.gif,.zip,.tar,.gz,.z';
//
//-------------------------------------------------------------------------------

if($debugAppli) $debugAppli->show('', "----------- getUploadedFile");
if($debugAppli) $debugAppli->show($inputFic, 'inputFic');
if($debugAppli) $debugAppli->show($dir, "dir");
if($debugAppli) $debugAppli->show($extOK, "extOK");
if($debugAppli) $debugAppli->show($goodExt, "goodExt");

//-------------------------------------------------------------------------------
/// Rcuprer le nom du fichier tlcharg et sa taille
/// (cf. interface php pour les inputs de type 'file')

      global $$inputFic;
      $tmpFic  = $$inputFic;          // Nom temporaire du fichier sur le serveur
      $ficUser = $inputFic.'_name';
      global $$ficUser;
      $ficUser = $$ficUser;           // Nom du fichier origine
      $size    = $inputFic.'_size';
      global $$size;
      $size    = $$size;              // Taille du fichier

if($debugAppli) $debugAppli->show($tmpFic, "tmpFic");
if($debugAppli) $debugAppli->show($ficUser, "ficUser");
if($debugAppli) $debugAppli->show($size, "size");
//-------------------------------------------------------------------------------
/// Traiter le cas d'un pb de chargement
      if(empty($tmpFic) || $tmpFic=='none') {

        $ficUser = '';                // Pas de fichier tlcharg
        if(empty($size) )
          $Erreur_getUpLoadedFile = "Fichier vide !";
        else
          $Erreur_getUpLoadedFile = "Problme au chargement ?!?";

      } else {
//-------------------------------------------------------------------------------
/// Rcuprer le fichier tlcharg : extraire nom et extension

        ereg('^(.*)(\.[^.]+)$',$ficUser, $regs);
        $nomFicUser = stripSlashes ($regs[1]);                          // Nom du fichier utilisateur
        $extFicUser = $regs[2];                                         // Extension du fichier utilisateur
if($debugAppli) $debugAppli->show($nomFicUser, "nomFicUser");
if($debugAppli) $debugAppli->show($extFicUser, "extFicUser");

/// Supprimer les caractres non autoriss dans le nom du fichier
        $nomFicUser = strtr ( $nomFicUser, $carsAccent, $carsSsAccent); // Pas de caractres accentus
        $nomFicUser = ereg_replace("[/'#:;()\\\"<>]",'',$nomFicUser);   // Pas d'apostrophes, ni de car. bizarres
        $nomFicUser = ereg_replace('  *','_',$nomFicUser);              // Pas d'espaces => '_'
        $nomFicUser = ereg_replace('^_+', '',$nomFicUser);
        $nomFicUser = ereg_replace('_+$', '',$nomFicUser);
if($debugAppli) $debugAppli->show($nomFicUser, "=> nomFicUser");

/// S'assurer que l'extension du fichier n'est pas interdite
        if(!$extOK) $extOK = $extFicUser;
        $extOK = strToLower( str_replace(' ','',$extOK) );              // Pas d'espaces
        if(strpos("_,$extOK,", ','.strToLower($extFicUser).',')         // Extensions autorises par l'appli
          && strpos("_,$goodExt,", ','.strToLower($extFicUser).',') ) { // Extensions non interdites en dur !

/// Contourner les collisions de noms
          $ficUser = $nomFicUser.$extFicUser;
          $iFic = 1;
          while(is_file("$dir/$ficUser")) {  // Collision => numroter
            $ficUser = $nomFicUser."_".$iFic.$extFicUser;
            $iFic ++ ;
          }
if($debugAppli) $debugAppli->show($ficUser, "=> ficUser");

//-------------------------------------------------------------------------------
/// Copier le fichier dans le rpertoire  "$dir"
          if(!move_uploaded_file($tmpFic, "$dir/$ficUser") ) {  // Dplacement KO

            $Erreur_getUpLoadedFile =
                 "Erreur...Votre fichier '$ficUser' n'a pas pu tre copi sur le serveur... \\n".
                 "Ayez l'obligeance de prvenir le webmaster".
                 "";
            $ficUser = '';
          } else {
            $ficUser = "$dir/$ficUser"; // On utilise le fichier transferr
          } // Fin if(!move_uploaded_file($Attachmnt, "../documents/$ficUser""))

        } else {
            $Erreur_getUpLoadedFile =
                 "Erreur...Votre fichier '$ficUser' n'est pas d'un type autoris sur le serveur... \\n".
                 "Seuls y sont transfrables les fichiers de types '$extOK'".
                 "\\nNB: La fiche sera cre... mais sans document attach !".
                 "";
            $ficUser = '';

        } // Fin if(eregi($extFicUser, '.txt,.csv')) ... else ...

      } // Fin if(empty($tmpFic) || $tmpFic=='none')... else...

if($debugAppli) $debugAppli->show($Erreur_getUpLoadedFile, "Erreur_getUpLoadedFile");
if($debugAppli) $debugAppli->show($ficUser, "Fin getUpLoadedFile ---- retour ficUser");

      return $ficUser;

    } // Fin function getUpLoadedFile($inputFic, $dir='', $extOK='.txt,.csv')

//-------------------------------------------------------------------------------
?>